# AlertsApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**alertsChangeGet**](AlertsApi.md#alertsChangeGet) | **GET** /alerts_change | Edit or insert new alert
[**alertsDeleteGet**](AlertsApi.md#alertsDeleteGet) | **GET** /alerts_delete | Permanently delete the alert
[**alertsGet**](AlertsApi.md#alertsGet) | **GET** /alerts | Get alerts for user account

<a name="alertsChangeGet"></a>
# **alertsChangeGet**
> kotlin.Array&lt;Domains&gt; alertsChangeGet(id, alertname, activated, type, channel, recipient, param1, param2, param3, param4, param5)

Edit or insert new alert

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = AlertsApi()
val id : kotlin.String = id_example // kotlin.String | ID of the alert to edit ; if adding a new one leave blank
val alertname : kotlin.String = alertname_example // kotlin.String | Name of the alert
val activated : kotlin.Boolean = true // kotlin.Boolean | Should the alert be activated or not
val type : kotlin.Int = 56 // kotlin.Int | Alert type (1= New content for website, 2=New perfirming contents)
val channel : kotlin.Int = 56 // kotlin.Int | 1 for email, 2 for Slack, 3 for Google Chat
val recipient : kotlin.String = recipient_example // kotlin.String | Email address of recipient or webhook for Slack/Gchat
val param1 : kotlin.String = param1_example // kotlin.String | Parameter 1 (meaning changes with alert type)
val param2 : kotlin.String = param2_example // kotlin.String | Parameter 2 (meaning changes with alert type)
val param3 : kotlin.String = param3_example // kotlin.String | Parameter 3 (meaning changes with alert type)
val param4 : kotlin.String = param4_example // kotlin.String | Parameter 4 (meaning changes with alert type)
val param5 : kotlin.String = param5_example // kotlin.String | Parameter 5 (meaning changes with alert type)
try {
    val result : kotlin.Array<Domains> = apiInstance.alertsChangeGet(id, alertname, activated, type, channel, recipient, param1, param2, param3, param4, param5)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling AlertsApi#alertsChangeGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling AlertsApi#alertsChangeGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **kotlin.String**| ID of the alert to edit ; if adding a new one leave blank |
 **alertname** | **kotlin.String**| Name of the alert |
 **activated** | **kotlin.Boolean**| Should the alert be activated or not |
 **type** | **kotlin.Int**| Alert type (1&#x3D; New content for website, 2&#x3D;New perfirming contents) |
 **channel** | **kotlin.Int**| 1 for email, 2 for Slack, 3 for Google Chat |
 **recipient** | **kotlin.String**| Email address of recipient or webhook for Slack/Gchat |
 **param1** | **kotlin.String**| Parameter 1 (meaning changes with alert type) | [optional]
 **param2** | **kotlin.String**| Parameter 2 (meaning changes with alert type) | [optional]
 **param3** | **kotlin.String**| Parameter 3 (meaning changes with alert type) | [optional]
 **param4** | **kotlin.String**| Parameter 4 (meaning changes with alert type) | [optional]
 **param5** | **kotlin.String**| Parameter 5 (meaning changes with alert type) | [optional]

### Return type

[**kotlin.Array&lt;Domains&gt;**](Domains.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="alertsDeleteGet"></a>
# **alertsDeleteGet**
> kotlin.Array&lt;TransactionInfo&gt; alertsDeleteGet(id)

Permanently delete the alert

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = AlertsApi()
val id : kotlin.String = id_example // kotlin.String | alert id to delete
try {
    val result : kotlin.Array<TransactionInfo> = apiInstance.alertsDeleteGet(id)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling AlertsApi#alertsDeleteGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling AlertsApi#alertsDeleteGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **kotlin.String**| alert id to delete |

### Return type

[**kotlin.Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="alertsGet"></a>
# **alertsGet**
> kotlin.Array&lt;Alerts&gt; alertsGet()

Get alerts for user account

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = AlertsApi()
try {
    val result : kotlin.Array<Alerts> = apiInstance.alertsGet()
    println(result)
} catch (e: ClientException) {
    println("4xx response calling AlertsApi#alertsGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling AlertsApi#alertsGet")
    e.printStackTrace()
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**kotlin.Array&lt;Alerts&gt;**](Alerts.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

