# FavsApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**favsAddGet**](FavsApi.md#favsAddGet) | **GET** /favs_add | Create a new fav
[**favsDeleteGet**](FavsApi.md#favsDeleteGet) | **GET** /favs_delete | Permanently delete the fav
[**favsGet**](FavsApi.md#favsGet) | **GET** /favs | Get favorites
[**favsUpdateGet**](FavsApi.md#favsUpdateGet) | **GET** /favs_update | Update the fav

<a name="favsAddGet"></a>
# **favsAddGet**
> kotlin.Array&lt;TransactionInfo&gt; favsAddGet(name, action, parameters)

Create a new fav

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = FavsApi()
val name : kotlin.String = name_example // kotlin.String | Name of the fav.
val action : kotlin.String = action_example // kotlin.String | Action to be opened.
val parameters : kotlin.String = parameters_example // kotlin.String | Action's parameters encoded in JSON.
try {
    val result : kotlin.Array<TransactionInfo> = apiInstance.favsAddGet(name, action, parameters)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling FavsApi#favsAddGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling FavsApi#favsAddGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **kotlin.String**| Name of the fav. | [optional]
 **action** | **kotlin.String**| Action to be opened. | [optional]
 **parameters** | **kotlin.String**| Action&#x27;s parameters encoded in JSON. | [optional]

### Return type

[**kotlin.Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="favsDeleteGet"></a>
# **favsDeleteGet**
> kotlin.Array&lt;TransactionInfo&gt; favsDeleteGet(id)

Permanently delete the fav

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = FavsApi()
val id : kotlin.String = id_example // kotlin.String | ID of the fav to delete.
try {
    val result : kotlin.Array<TransactionInfo> = apiInstance.favsDeleteGet(id)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling FavsApi#favsDeleteGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling FavsApi#favsDeleteGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **kotlin.String**| ID of the fav to delete. | [optional]

### Return type

[**kotlin.Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="favsGet"></a>
# **favsGet**
> kotlin.Array&lt;Favs&gt; favsGet(id)

Get favorites

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = FavsApi()
val id : kotlin.String = id_example // kotlin.String | ID of the requested fav. ignore or set to 0 to get the full favs list
try {
    val result : kotlin.Array<Favs> = apiInstance.favsGet(id)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling FavsApi#favsGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling FavsApi#favsGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **kotlin.String**| ID of the requested fav. ignore or set to 0 to get the full favs list | [optional]

### Return type

[**kotlin.Array&lt;Favs&gt;**](Favs.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="favsUpdateGet"></a>
# **favsUpdateGet**
> kotlin.Array&lt;TransactionInfo&gt; favsUpdateGet(id, name, action, parameters, scheduled, scheduledto)

Update the fav

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = FavsApi()
val id : kotlin.String = id_example // kotlin.String | ID of the fav that should be edited
val name : kotlin.String = name_example // kotlin.String | Name of the fav.
val action : kotlin.String = action_example // kotlin.String | Action to be opened.
val parameters : kotlin.String = parameters_example // kotlin.String | Action's parameters encoded in JSON.
val scheduled : kotlin.Int = 56 // kotlin.Int | 0 if not scheduled, else x in hours
val scheduledto : kotlin.String = scheduledto_example // kotlin.String | email address of the recipient of this report
try {
    val result : kotlin.Array<TransactionInfo> = apiInstance.favsUpdateGet(id, name, action, parameters, scheduled, scheduledto)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling FavsApi#favsUpdateGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling FavsApi#favsUpdateGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **kotlin.String**| ID of the fav that should be edited |
 **name** | **kotlin.String**| Name of the fav. | [optional]
 **action** | **kotlin.String**| Action to be opened. | [optional]
 **parameters** | **kotlin.String**| Action&#x27;s parameters encoded in JSON. | [optional]
 **scheduled** | **kotlin.Int**| 0 if not scheduled, else x in hours | [optional]
 **scheduledto** | **kotlin.String**| email address of the recipient of this report | [optional]

### Return type

[**kotlin.Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

