# KbApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**kbArticlesGet**](KbApi.md#kbArticlesGet) | **GET** /kb_articles | Get knowledge base articles

<a name="kbArticlesGet"></a>
# **kbArticlesGet**
> kotlin.Array&lt;KB&gt; kbArticlesGet(article)

Get knowledge base articles

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = KbApi()
val article : kotlin.Int = 56 // kotlin.Int | ID of the requested article. 0 to get the full article list
try {
    val result : kotlin.Array<KB> = apiInstance.kbArticlesGet(article)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling KbApi#kbArticlesGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling KbApi#kbArticlesGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **article** | **kotlin.Int**| ID of the requested article. 0 to get the full article list | [optional]

### Return type

[**kotlin.Array&lt;KB&gt;**](KB.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

