# UserApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**userCountriesChangeGet**](UserApi.md#userCountriesChangeGet) | **GET** /user_countries_change | Change user&#x27;s activated countries
[**userCustidChangeGet**](UserApi.md#userCustidChangeGet) | **GET** /user_custid_change | Change user customer id. This function is system reserved
[**userDeleteGet**](UserApi.md#userDeleteGet) | **GET** /user_delete | Permanently delete the user
[**userDetailsChangeGet**](UserApi.md#userDetailsChangeGet) | **GET** /user_details_change | Change user details
[**userLoginGet**](UserApi.md#userLoginGet) | **GET** /user_login | Login user with his credentials
[**userMessagesGet**](UserApi.md#userMessagesGet) | **GET** /user_messages | Get messages for user
[**userPasswordChangeGet**](UserApi.md#userPasswordChangeGet) | **GET** /user_password_change | Change user password
[**userPasswordResetGet**](UserApi.md#userPasswordResetGet) | **GET** /user_password_reset | Reset user password
[**userRefreshSubscriptionGet**](UserApi.md#userRefreshSubscriptionGet) | **GET** /user_refresh_subscription | Refresh user rights with his Customer ID. This function is system reserved
[**userRegisterGet**](UserApi.md#userRegisterGet) | **GET** /user_register | Login user with his credentials

<a name="userCountriesChangeGet"></a>
# **userCountriesChangeGet**
> kotlin.Array&lt;TransactionInfo&gt; userCountriesChangeGet(countries, categories)

Change user&#x27;s activated countries

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = UserApi()
val countries : kotlin.String = countries_example // kotlin.String | json encoded string representing countries to activate
val categories : kotlin.String = categories_example // kotlin.String | json encoded string representing categories ID to activate
try {
    val result : kotlin.Array<TransactionInfo> = apiInstance.userCountriesChangeGet(countries, categories)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling UserApi#userCountriesChangeGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling UserApi#userCountriesChangeGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **countries** | **kotlin.String**| json encoded string representing countries to activate |
 **categories** | **kotlin.String**| json encoded string representing categories ID to activate |

### Return type

[**kotlin.Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userCustidChangeGet"></a>
# **userCustidChangeGet**
> kotlin.Array&lt;TransactionInfo&gt; userCustidChangeGet(custid)

Change user customer id. This function is system reserved

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = UserApi()
val custid : kotlin.String = custid_example // kotlin.String | new customer id for user
try {
    val result : kotlin.Array<TransactionInfo> = apiInstance.userCustidChangeGet(custid)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling UserApi#userCustidChangeGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling UserApi#userCustidChangeGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **custid** | **kotlin.String**| new customer id for user |

### Return type

[**kotlin.Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userDeleteGet"></a>
# **userDeleteGet**
> kotlin.Array&lt;TransactionInfo&gt; userDeleteGet()

Permanently delete the user

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = UserApi()
try {
    val result : kotlin.Array<TransactionInfo> = apiInstance.userDeleteGet()
    println(result)
} catch (e: ClientException) {
    println("4xx response calling UserApi#userDeleteGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling UserApi#userDeleteGet")
    e.printStackTrace()
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**kotlin.Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userDetailsChangeGet"></a>
# **userDetailsChangeGet**
> kotlin.Array&lt;TransactionInfo&gt; userDetailsChangeGet(email, fname, lname)

Change user details

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = UserApi()
val email : kotlin.String = email_example // kotlin.String | new email address for user
val fname : kotlin.String = fname_example // kotlin.String | new firstname for user
val lname : kotlin.String = lname_example // kotlin.String | new lastname for user
try {
    val result : kotlin.Array<TransactionInfo> = apiInstance.userDetailsChangeGet(email, fname, lname)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling UserApi#userDetailsChangeGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling UserApi#userDetailsChangeGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **kotlin.String**| new email address for user |
 **fname** | **kotlin.String**| new firstname for user |
 **lname** | **kotlin.String**| new lastname for user |

### Return type

[**kotlin.Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userLoginGet"></a>
# **userLoginGet**
> kotlin.Array&lt;UserInfo&gt; userLoginGet(email, password, pin)

Login user with his credentials

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = UserApi()
val email : kotlin.String = email_example // kotlin.String | email address for user
val password : kotlin.String = password_example // kotlin.String | password for user
val pin : kotlin.Int = 56 // kotlin.Int | pin code to validate account creation ; when using pin code, password must be set to \"loginwithpin\"
try {
    val result : kotlin.Array<UserInfo> = apiInstance.userLoginGet(email, password, pin)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling UserApi#userLoginGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling UserApi#userLoginGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **kotlin.String**| email address for user |
 **password** | **kotlin.String**| password for user |
 **pin** | **kotlin.Int**| pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; | [optional]

### Return type

[**kotlin.Array&lt;UserInfo&gt;**](UserInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userMessagesGet"></a>
# **userMessagesGet**
> kotlin.Array&lt;Message&gt; userMessagesGet(message)

Get messages for user

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = UserApi()
val message : kotlin.Int = 56 // kotlin.Int | ID of the requested message. 0 to get the full message list
try {
    val result : kotlin.Array<Message> = apiInstance.userMessagesGet(message)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling UserApi#userMessagesGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling UserApi#userMessagesGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **message** | **kotlin.Int**| ID of the requested message. 0 to get the full message list | [optional]

### Return type

[**kotlin.Array&lt;Message&gt;**](Message.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userPasswordChangeGet"></a>
# **userPasswordChangeGet**
> kotlin.Array&lt;TransactionInfo&gt; userPasswordChangeGet(email, password, newpassword)

Change user password

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = UserApi()
val email : kotlin.String = email_example // kotlin.String | email address for user
val password : kotlin.String = password_example // kotlin.String | current password for user
val newpassword : kotlin.String = newpassword_example // kotlin.String | new password to set up for user
try {
    val result : kotlin.Array<TransactionInfo> = apiInstance.userPasswordChangeGet(email, password, newpassword)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling UserApi#userPasswordChangeGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling UserApi#userPasswordChangeGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **kotlin.String**| email address for user |
 **password** | **kotlin.String**| current password for user |
 **newpassword** | **kotlin.String**| new password to set up for user |

### Return type

[**kotlin.Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userPasswordResetGet"></a>
# **userPasswordResetGet**
> kotlin.Array&lt;TransactionInfo&gt; userPasswordResetGet(email)

Reset user password

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = UserApi()
val email : kotlin.String = email_example // kotlin.String | email address for user
try {
    val result : kotlin.Array<TransactionInfo> = apiInstance.userPasswordResetGet(email)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling UserApi#userPasswordResetGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling UserApi#userPasswordResetGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **kotlin.String**| email address for user |

### Return type

[**kotlin.Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userRefreshSubscriptionGet"></a>
# **userRefreshSubscriptionGet**
> kotlin.Array&lt;UserInfo&gt; userRefreshSubscriptionGet(custid)

Refresh user rights with his Customer ID. This function is system reserved

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = UserApi()
val custid : kotlin.String = custid_example // kotlin.String | Customer ID for the user
try {
    val result : kotlin.Array<UserInfo> = apiInstance.userRefreshSubscriptionGet(custid)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling UserApi#userRefreshSubscriptionGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling UserApi#userRefreshSubscriptionGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **custid** | **kotlin.String**| Customer ID for the user |

### Return type

[**kotlin.Array&lt;UserInfo&gt;**](UserInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userRegisterGet"></a>
# **userRegisterGet**
> kotlin.Array&lt;UserInfo&gt; userRegisterGet(email, password, fname, lname, referrer)

Login user with his credentials

### Example
```kotlin
// Import classes:
//import io.swagger.client.infrastructure.*
//import io.swagger.client.models.*;

val apiInstance = UserApi()
val email : kotlin.String = email_example // kotlin.String | email address for user
val password : kotlin.String = password_example // kotlin.String | password for user
val fname : kotlin.String = fname_example // kotlin.String | new firstname for user
val lname : kotlin.String = lname_example // kotlin.String | new lastname for user
val referrer : kotlin.String = referrer_example // kotlin.String | referrer for this user. should be urlencoded
try {
    val result : kotlin.Array<UserInfo> = apiInstance.userRegisterGet(email, password, fname, lname, referrer)
    println(result)
} catch (e: ClientException) {
    println("4xx response calling UserApi#userRegisterGet")
    e.printStackTrace()
} catch (e: ServerException) {
    println("5xx response calling UserApi#userRegisterGet")
    e.printStackTrace()
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **kotlin.String**| email address for user |
 **password** | **kotlin.String**| password for user |
 **fname** | **kotlin.String**| new firstname for user |
 **lname** | **kotlin.String**| new lastname for user |
 **referrer** | **kotlin.String**| referrer for this user. should be urlencoded | [optional]

### Return type

[**kotlin.Array&lt;UserInfo&gt;**](UserInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

