/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package io.swagger.client.apis

import io.swagger.client.models.Alerts
import io.swagger.client.models.Domains
import io.swagger.client.models.TransactionInfo

import io.swagger.client.infrastructure.*

class AlertsApi(basePath: kotlin.String = "https://api.discoversnoop.com") : ApiClient(basePath) {

    /**
     * Edit or insert new alert
     * 
     * @param id ID of the alert to edit ; if adding a new one leave blank 
     * @param alertname Name of the alert 
     * @param activated Should the alert be activated or not 
     * @param type Alert type (1&#x3D; New content for website, 2&#x3D;New perfirming contents) 
     * @param channel 1 for email, 2 for Slack, 3 for Google Chat 
     * @param recipient Email address of recipient or webhook for Slack/Gchat 
     * @param param1 Parameter 1 (meaning changes with alert type) (optional)
     * @param param2 Parameter 2 (meaning changes with alert type) (optional)
     * @param param3 Parameter 3 (meaning changes with alert type) (optional)
     * @param param4 Parameter 4 (meaning changes with alert type) (optional)
     * @param param5 Parameter 5 (meaning changes with alert type) (optional)
     * @return kotlin.Array<Domains>
     */
    @Suppress("UNCHECKED_CAST")
    fun alertsChangeGet(id: kotlin.String, alertname: kotlin.String, activated: kotlin.Boolean, type: kotlin.Int, channel: kotlin.Int, recipient: kotlin.String, param1: kotlin.String? = null, param2: kotlin.String? = null, param3: kotlin.String? = null, param4: kotlin.String? = null, param5: kotlin.String? = null): kotlin.Array<Domains> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("id", listOf(id.toString()))
            put("alertname", listOf(alertname.toString()))
            put("activated", listOf(activated.toString()))
            put("type", listOf(type.toString()))
            put("channel", listOf(channel.toString()))
            put("recipient", listOf(recipient.toString()))
            if (param1 != null) {
                put("param1", listOf(param1.toString()))
            }
            if (param2 != null) {
                put("param2", listOf(param2.toString()))
            }
            if (param3 != null) {
                put("param3", listOf(param3.toString()))
            }
            if (param4 != null) {
                put("param4", listOf(param4.toString()))
            }
            if (param5 != null) {
                put("param5", listOf(param5.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/alerts_change", query = localVariableQuery
        )
        val response = request<kotlin.Array<Domains>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<Domains>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Permanently delete the alert
     * 
     * @param id alert id to delete 
     * @return kotlin.Array<TransactionInfo>
     */
    @Suppress("UNCHECKED_CAST")
    fun alertsDeleteGet(id: kotlin.String): kotlin.Array<TransactionInfo> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("id", listOf(id.toString()))
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/alerts_delete", query = localVariableQuery
        )
        val response = request<kotlin.Array<TransactionInfo>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<TransactionInfo>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Get alerts for user account
     * 
     * @return kotlin.Array<Alerts>
     */
    @Suppress("UNCHECKED_CAST")
    fun alertsGet(): kotlin.Array<Alerts> {
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/alerts"
        )
        val response = request<kotlin.Array<Alerts>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<Alerts>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
}
