/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package io.swagger.client.apis

import io.swagger.client.models.Favs
import io.swagger.client.models.TransactionInfo

import io.swagger.client.infrastructure.*

class FavsApi(basePath: kotlin.String = "https://api.discoversnoop.com") : ApiClient(basePath) {

    /**
     * Create a new fav
     * 
     * @param name Name of the fav. (optional)
     * @param action Action to be opened. (optional)
     * @param parameters Action&#x27;s parameters encoded in JSON. (optional)
     * @return kotlin.Array<TransactionInfo>
     */
    @Suppress("UNCHECKED_CAST")
    fun favsAddGet(name: kotlin.String? = null, action: kotlin.String? = null, parameters: kotlin.String? = null): kotlin.Array<TransactionInfo> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (name != null) {
                put("name", listOf(name.toString()))
            }
            if (action != null) {
                put("action", listOf(action.toString()))
            }
            if (parameters != null) {
                put("parameters", listOf(parameters.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/favs_add", query = localVariableQuery
        )
        val response = request<kotlin.Array<TransactionInfo>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<TransactionInfo>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Permanently delete the fav
     * 
     * @param id ID of the fav to delete. (optional)
     * @return kotlin.Array<TransactionInfo>
     */
    @Suppress("UNCHECKED_CAST")
    fun favsDeleteGet(id: kotlin.String? = null): kotlin.Array<TransactionInfo> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (id != null) {
                put("id", listOf(id.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/favs_delete", query = localVariableQuery
        )
        val response = request<kotlin.Array<TransactionInfo>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<TransactionInfo>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Get favorites
     * 
     * @param id ID of the requested fav. ignore or set to 0 to get the full favs list (optional)
     * @return kotlin.Array<Favs>
     */
    @Suppress("UNCHECKED_CAST")
    fun favsGet(id: kotlin.String? = null): kotlin.Array<Favs> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (id != null) {
                put("id", listOf(id.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/favs", query = localVariableQuery
        )
        val response = request<kotlin.Array<Favs>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<Favs>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Update the fav
     * 
     * @param id ID of the fav that should be edited 
     * @param name Name of the fav. (optional)
     * @param action Action to be opened. (optional)
     * @param parameters Action&#x27;s parameters encoded in JSON. (optional)
     * @param scheduled 0 if not scheduled, else x in hours (optional)
     * @param scheduledto email address of the recipient of this report (optional)
     * @return kotlin.Array<TransactionInfo>
     */
    @Suppress("UNCHECKED_CAST")
    fun favsUpdateGet(id: kotlin.String, name: kotlin.String? = null, action: kotlin.String? = null, parameters: kotlin.String? = null, scheduled: kotlin.Int? = null, scheduledto: kotlin.String? = null): kotlin.Array<TransactionInfo> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("id", listOf(id.toString()))
            if (name != null) {
                put("name", listOf(name.toString()))
            }
            if (action != null) {
                put("action", listOf(action.toString()))
            }
            if (parameters != null) {
                put("parameters", listOf(parameters.toString()))
            }
            if (scheduled != null) {
                put("scheduled", listOf(scheduled.toString()))
            }
            if (scheduledto != null) {
                put("scheduledto", listOf(scheduledto.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/favs_update", query = localVariableQuery
        )
        val response = request<kotlin.Array<TransactionInfo>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<TransactionInfo>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
}
