/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package io.swagger.client.apis

import io.swagger.client.models.Categories
import io.swagger.client.models.Category
import io.swagger.client.models.Domain
import io.swagger.client.models.Domains
import io.swagger.client.models.Page
import io.swagger.client.models.Pages

import io.swagger.client.infrastructure.*

class HistoricalApi(basePath: kotlin.String = "https://api.discoversnoop.com") : ApiClient(basePath) {

    /**
     * Get historical stats for categories
     * 
     * @param country ISO_3166 country code in 2 letters 
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param keywordFilter Filter answers to cateogry names containing a particular keyword (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return kotlin.Array<Categories>
     */
    @Suppress("UNCHECKED_CAST")
    fun categoriesGet(country: kotlin.String, subcountry: kotlin.String? = null, fromDate: kotlin.String? = null, toDate: kotlin.String? = null, keywordFilter: kotlin.String? = null, lines: kotlin.Int? = null, offset: kotlin.Int? = null): kotlin.Array<Categories> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("country", listOf(country.toString()))
            if (subcountry != null) {
                put("subcountry", listOf(subcountry.toString()))
            }
            if (fromDate != null) {
                put("from_date", listOf(fromDate.toString()))
            }
            if (toDate != null) {
                put("to_date", listOf(toDate.toString()))
            }
            if (keywordFilter != null) {
                put("keyword_filter", listOf(keywordFilter.toString()))
            }
            if (lines != null) {
                put("lines", listOf(lines.toString()))
            }
            if (offset != null) {
                put("offset", listOf(offset.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/categories", query = localVariableQuery
        )
        val response = request<kotlin.Array<Categories>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<Categories>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Get history for category ID
     * 
     * @param id category id 
     * @param country ISO_3166 country code in 2 letters 
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @return kotlin.Array<Category>
     */
    @Suppress("UNCHECKED_CAST")
    fun categoryGet(id: kotlin.String, country: kotlin.String, subcountry: kotlin.String? = null, fromDate: kotlin.String? = null, toDate: kotlin.String? = null): kotlin.Array<Category> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("id", listOf(id.toString()))
            put("country", listOf(country.toString()))
            if (subcountry != null) {
                put("subcountry", listOf(subcountry.toString()))
            }
            if (fromDate != null) {
                put("from_date", listOf(fromDate.toString()))
            }
            if (toDate != null) {
                put("to_date", listOf(toDate.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/category", query = localVariableQuery
        )
        val response = request<kotlin.Array<Category>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<Category>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Get history for domain name
     * 
     * @param domain domain name (no subdomain allowed) 
     * @param country ISO_3166 country code in 2 letters 
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @return kotlin.Array<Domain>
     */
    @Suppress("UNCHECKED_CAST")
    fun domainGet(domain: kotlin.String, country: kotlin.String, subcountry: kotlin.String? = null, fromDate: kotlin.String? = null, toDate: kotlin.String? = null): kotlin.Array<Domain> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("domain", listOf(domain.toString()))
            put("country", listOf(country.toString()))
            if (subcountry != null) {
                put("subcountry", listOf(subcountry.toString()))
            }
            if (fromDate != null) {
                put("from_date", listOf(fromDate.toString()))
            }
            if (toDate != null) {
                put("to_date", listOf(toDate.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/domain", query = localVariableQuery
        )
        val response = request<kotlin.Array<Domain>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<Domain>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Get historical stats for domains
     * 
     * @param country ISO_3166 country code in 2 letters 
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param urlFilter Filter answers to domains including a specified string (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return kotlin.Array<Domains>
     */
    @Suppress("UNCHECKED_CAST")
    fun domainsGet(country: kotlin.String, subcountry: kotlin.String? = null, fromDate: kotlin.String? = null, toDate: kotlin.String? = null, urlFilter: kotlin.String? = null, lines: kotlin.Int? = null, offset: kotlin.Int? = null): kotlin.Array<Domains> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("country", listOf(country.toString()))
            if (subcountry != null) {
                put("subcountry", listOf(subcountry.toString()))
            }
            if (fromDate != null) {
                put("from_date", listOf(fromDate.toString()))
            }
            if (toDate != null) {
                put("to_date", listOf(toDate.toString()))
            }
            if (urlFilter != null) {
                put("url_filter", listOf(urlFilter.toString()))
            }
            if (lines != null) {
                put("lines", listOf(lines.toString()))
            }
            if (offset != null) {
                put("offset", listOf(offset.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/domains", query = localVariableQuery
        )
        val response = request<kotlin.Array<Domains>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<Domains>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Get page history for URL
     * 
     * @param url Fully qualified page url. URL needs to be URL encoded 
     * @param country ISO_3166 country code in 2 letters 
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @return kotlin.Array<Page>
     */
    @Suppress("UNCHECKED_CAST")
    fun pageGet(url: kotlin.String, country: kotlin.String, subcountry: kotlin.String? = null, fromDate: kotlin.String? = null, toDate: kotlin.String? = null): kotlin.Array<Page> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("url", listOf(url.toString()))
            put("country", listOf(country.toString()))
            if (subcountry != null) {
                put("subcountry", listOf(subcountry.toString()))
            }
            if (fromDate != null) {
                put("from_date", listOf(fromDate.toString()))
            }
            if (toDate != null) {
                put("to_date", listOf(toDate.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/page", query = localVariableQuery
        )
        val response = request<kotlin.Array<Page>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<Page>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Get historical stats for pages
     * 
     * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone 
     * @param fromDate Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param country ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)
     * @param subcountry state code (optional)
     * @param domainFilter Filter answers to pages of a designated domain name (optional)
     * @param urlFilter Filter answers to pages URL including a specified string (optional)
     * @param categoryFilter Filter answers to a specific page category (optional)
     * @param keywordFilter Filter answers to pages titles containing a particular keyword (optional)
     * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return kotlin.Array<Pages>
     */
    @Suppress("UNCHECKED_CAST")
    fun pagesGet(presetFilter: kotlin.Int, fromDate: kotlin.String? = null, toDate: kotlin.String? = null, country: kotlin.String? = null, subcountry: kotlin.String? = null, domainFilter: kotlin.String? = null, urlFilter: kotlin.String? = null, categoryFilter: kotlin.Int? = null, keywordFilter: kotlin.String? = null, lines: kotlin.Int? = null, offset: kotlin.Int? = null): kotlin.Array<Pages> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (fromDate != null) {
                put("from_date", listOf(fromDate.toString()))
            }
            if (toDate != null) {
                put("to_date", listOf(toDate.toString()))
            }
            if (country != null) {
                put("country", listOf(country.toString()))
            }
            if (subcountry != null) {
                put("subcountry", listOf(subcountry.toString()))
            }
            if (domainFilter != null) {
                put("domain_filter", listOf(domainFilter.toString()))
            }
            if (urlFilter != null) {
                put("url_filter", listOf(urlFilter.toString()))
            }
            if (categoryFilter != null) {
                put("category_filter", listOf(categoryFilter.toString()))
            }
            if (keywordFilter != null) {
                put("keyword_filter", listOf(keywordFilter.toString()))
            }
            put("preset_filter", listOf(presetFilter.toString()))
            if (lines != null) {
                put("lines", listOf(lines.toString()))
            }
            if (offset != null) {
                put("offset", listOf(offset.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/pages", query = localVariableQuery
        )
        val response = request<kotlin.Array<Pages>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<Pages>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
}
