/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package io.swagger.client.apis

import io.swagger.client.models.Categories
import io.swagger.client.models.Domains
import io.swagger.client.models.Pages

import io.swagger.client.infrastructure.*

class LiveApi(basePath: kotlin.String = "https://api.discoversnoop.com") : ApiClient(basePath) {

    /**
     * Get livedata stats for categories
     * 
     * @param country ISO_3166 country code in 2 letters 
     * @param subcountry state code (optional)
     * @param hours Get results for last x hours (optional)
     * @param keywordFilter Filter answers to category names containing a particular keyword (optional)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return kotlin.Array<Categories>
     */
    @Suppress("UNCHECKED_CAST")
    fun livecategoriesGet(country: kotlin.String, subcountry: kotlin.String? = null, hours: kotlin.Int? = null, keywordFilter: kotlin.String? = null, languageFilter: kotlin.String? = null, lines: kotlin.Int? = null, offset: kotlin.Int? = null): kotlin.Array<Categories> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("country", listOf(country.toString()))
            if (subcountry != null) {
                put("subcountry", listOf(subcountry.toString()))
            }
            if (hours != null) {
                put("hours", listOf(hours.toString()))
            }
            if (keywordFilter != null) {
                put("keyword_filter", listOf(keywordFilter.toString()))
            }
            if (languageFilter != null) {
                put("language_filter", listOf(languageFilter.toString()))
            }
            if (lines != null) {
                put("lines", listOf(lines.toString()))
            }
            if (offset != null) {
                put("offset", listOf(offset.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/livecategories", query = localVariableQuery
        )
        val response = request<kotlin.Array<Categories>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<Categories>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Get livedata stats for domains
     * 
     * @param country ISO_3166 country code in 2 letters 
     * @param subcountry state code (optional)
     * @param urlFilter Filter answers to domains including a specified string (optional)
     * @param hours Get results for last x hours (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return kotlin.Array<Domains>
     */
    @Suppress("UNCHECKED_CAST")
    fun livedomainsGet(country: kotlin.String, subcountry: kotlin.String? = null, urlFilter: kotlin.String? = null, hours: kotlin.Int? = null, lines: kotlin.Int? = null, languageFilter: kotlin.String? = null, offset: kotlin.Int? = null): kotlin.Array<Domains> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("country", listOf(country.toString()))
            if (subcountry != null) {
                put("subcountry", listOf(subcountry.toString()))
            }
            if (urlFilter != null) {
                put("url_filter", listOf(urlFilter.toString()))
            }
            if (hours != null) {
                put("hours", listOf(hours.toString()))
            }
            if (lines != null) {
                put("lines", listOf(lines.toString()))
            }
            if (languageFilter != null) {
                put("language_filter", listOf(languageFilter.toString()))
            }
            if (offset != null) {
                put("offset", listOf(offset.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/livedomains", query = localVariableQuery
        )
        val response = request<kotlin.Array<Domains>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<Domains>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Get livedata stats for pages
     * 
     * @param country ISO_3166 country code in 2 letters 
     * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone 
     * @param subcountry state code (optional)
     * @param hours Get results for last x hours (optional)
     * @param onlyNew Get only pages first seen in the reporting period if set on 1 (optional, default to 0)
     * @param domainFilter Filter answers to pages of a designated domain name (optional)
     * @param keywordFilter Filter answers to pages titles containing a particular keyword (optional)
     * @param urlFilter Filter answers to pages URL including a specified string (optional)
     * @param categoryFilter Filter answers to pages of a designated category id (optional)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return kotlin.Array<Pages>
     */
    @Suppress("UNCHECKED_CAST")
    fun livepagesGet(country: kotlin.String, presetFilter: kotlin.Int, subcountry: kotlin.String? = null, hours: kotlin.Int? = null, onlyNew: kotlin.Int? = null, domainFilter: kotlin.String? = null, keywordFilter: kotlin.String? = null, urlFilter: kotlin.String? = null, categoryFilter: kotlin.Int? = null, languageFilter: kotlin.String? = null, lines: kotlin.Int? = null, offset: kotlin.Int? = null): kotlin.Array<Pages> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("country", listOf(country.toString()))
            if (subcountry != null) {
                put("subcountry", listOf(subcountry.toString()))
            }
            if (hours != null) {
                put("hours", listOf(hours.toString()))
            }
            put("preset_filter", listOf(presetFilter.toString()))
            if (onlyNew != null) {
                put("only_new", listOf(onlyNew.toString()))
            }
            if (domainFilter != null) {
                put("domain_filter", listOf(domainFilter.toString()))
            }
            if (keywordFilter != null) {
                put("keyword_filter", listOf(keywordFilter.toString()))
            }
            if (urlFilter != null) {
                put("url_filter", listOf(urlFilter.toString()))
            }
            if (categoryFilter != null) {
                put("category_filter", listOf(categoryFilter.toString()))
            }
            if (languageFilter != null) {
                put("language_filter", listOf(languageFilter.toString()))
            }
            if (lines != null) {
                put("lines", listOf(lines.toString()))
            }
            if (offset != null) {
                put("offset", listOf(offset.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/livepages", query = localVariableQuery
        )
        val response = request<kotlin.Array<Pages>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<Pages>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
}
