/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package io.swagger.client.apis

import io.swagger.client.models.Message
import io.swagger.client.models.TransactionInfo
import io.swagger.client.models.UserInfo

import io.swagger.client.infrastructure.*

class UserApi(basePath: kotlin.String = "https://api.discoversnoop.com") : ApiClient(basePath) {

    /**
     * Change user&#x27;s activated countries
     * 
     * @param countries json encoded string representing countries to activate 
     * @param categories json encoded string representing categories ID to activate 
     * @return kotlin.Array<TransactionInfo>
     */
    @Suppress("UNCHECKED_CAST")
    fun userCountriesChangeGet(countries: kotlin.String, categories: kotlin.String): kotlin.Array<TransactionInfo> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("countries", listOf(countries.toString()))
            put("categories", listOf(categories.toString()))
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/user_countries_change", query = localVariableQuery
        )
        val response = request<kotlin.Array<TransactionInfo>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<TransactionInfo>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Change user customer id. This function is system reserved
     * 
     * @param custid new customer id for user 
     * @return kotlin.Array<TransactionInfo>
     */
    @Suppress("UNCHECKED_CAST")
    fun userCustidChangeGet(custid: kotlin.String): kotlin.Array<TransactionInfo> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("custid", listOf(custid.toString()))
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/user_custid_change", query = localVariableQuery
        )
        val response = request<kotlin.Array<TransactionInfo>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<TransactionInfo>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Permanently delete the user
     * 
     * @return kotlin.Array<TransactionInfo>
     */
    @Suppress("UNCHECKED_CAST")
    fun userDeleteGet(): kotlin.Array<TransactionInfo> {
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/user_delete"
        )
        val response = request<kotlin.Array<TransactionInfo>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<TransactionInfo>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Change user details
     * 
     * @param email new email address for user 
     * @param fname new firstname for user 
     * @param lname new lastname for user 
     * @return kotlin.Array<TransactionInfo>
     */
    @Suppress("UNCHECKED_CAST")
    fun userDetailsChangeGet(email: kotlin.String, fname: kotlin.String, lname: kotlin.String): kotlin.Array<TransactionInfo> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("email", listOf(email.toString()))
            put("fname", listOf(fname.toString()))
            put("lname", listOf(lname.toString()))
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/user_details_change", query = localVariableQuery
        )
        val response = request<kotlin.Array<TransactionInfo>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<TransactionInfo>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Login user with his credentials
     * 
     * @param email email address for user 
     * @param password password for user 
     * @param pin pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)
     * @return kotlin.Array<UserInfo>
     */
    @Suppress("UNCHECKED_CAST")
    fun userLoginGet(email: kotlin.String, password: kotlin.String, pin: kotlin.Int? = null): kotlin.Array<UserInfo> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("email", listOf(email.toString()))
            put("password", listOf(password.toString()))
            if (pin != null) {
                put("pin", listOf(pin.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/user_login", query = localVariableQuery
        )
        val response = request<kotlin.Array<UserInfo>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<UserInfo>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Get messages for user
     * 
     * @param message ID of the requested message. 0 to get the full message list (optional)
     * @return kotlin.Array<Message>
     */
    @Suppress("UNCHECKED_CAST")
    fun userMessagesGet(message: kotlin.Int? = null): kotlin.Array<Message> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (message != null) {
                put("message", listOf(message.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/user_messages", query = localVariableQuery
        )
        val response = request<kotlin.Array<Message>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<Message>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Change user password
     * 
     * @param email email address for user 
     * @param password current password for user 
     * @param newpassword new password to set up for user 
     * @return kotlin.Array<TransactionInfo>
     */
    @Suppress("UNCHECKED_CAST")
    fun userPasswordChangeGet(email: kotlin.String, password: kotlin.String, newpassword: kotlin.String): kotlin.Array<TransactionInfo> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("email", listOf(email.toString()))
            put("password", listOf(password.toString()))
            put("newpassword", listOf(newpassword.toString()))
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/user_password_change", query = localVariableQuery
        )
        val response = request<kotlin.Array<TransactionInfo>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<TransactionInfo>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Reset user password
     * 
     * @param email email address for user 
     * @return kotlin.Array<TransactionInfo>
     */
    @Suppress("UNCHECKED_CAST")
    fun userPasswordResetGet(email: kotlin.String): kotlin.Array<TransactionInfo> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("email", listOf(email.toString()))
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/user_password_reset", query = localVariableQuery
        )
        val response = request<kotlin.Array<TransactionInfo>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<TransactionInfo>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Refresh user rights with his Customer ID. This function is system reserved
     * 
     * @param custid Customer ID for the user 
     * @return kotlin.Array<UserInfo>
     */
    @Suppress("UNCHECKED_CAST")
    fun userRefreshSubscriptionGet(custid: kotlin.String): kotlin.Array<UserInfo> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("custid", listOf(custid.toString()))
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/user_refresh_subscription", query = localVariableQuery
        )
        val response = request<kotlin.Array<UserInfo>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<UserInfo>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * Login user with his credentials
     * 
     * @param email email address for user 
     * @param password password for user 
     * @param fname new firstname for user 
     * @param lname new lastname for user 
     * @param referrer referrer for this user. should be urlencoded (optional)
     * @return kotlin.Array<UserInfo>
     */
    @Suppress("UNCHECKED_CAST")
    fun userRegisterGet(email: kotlin.String, password: kotlin.String, fname: kotlin.String, lname: kotlin.String, referrer: kotlin.String? = null): kotlin.Array<UserInfo> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            put("email", listOf(email.toString()))
            put("password", listOf(password.toString()))
            put("fname", listOf(fname.toString()))
            put("lname", listOf(lname.toString()))
            if (referrer != null) {
                put("referrer", listOf(referrer.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/user_register", query = localVariableQuery
        )
        val response = request<kotlin.Array<UserInfo>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<UserInfo>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
}
